import java.util.ArrayList;
import java.util.HashMap;
import java.util.HashSet;

public class Firma{

    private String naziv;
    private ArrayList<Projekat> projekti;
    private HashMap<String, Zaposleni> zaposleni;
    
    public Firma(String naziv){
        this.naziv=naziv;
        projekti = new ArrayList<>();
        zaposleni = new HashMap<>();
    }
    
    //1
    public Firma(String naziv, ArrayList<Projekat> projekti, HashMap<String, Zaposleni> zaposleni){
        this.naziv=naziv;
        this.projekti = projekti;
        this.zaposleni = zaposleni;
    }
    
    public void dodajZaposlenog(Zaposleni z){zaposleni.put(z.dajJMBG(),z);}
    public void dodajProjekat(Projekat p){projekti.add(p);}   
    
    public void info(){
        for(Projekat p:projekti){
            System.out.println(p.toString());
        }
    }
    
    //8
    public Projekat najmanjaCena(){
        double minc=10^20;
        Projekat minP=null;
        for(Projekat p:projekti){
            if(p instanceof Infrastruktura){
                if(p.dajCenu()<minc){
                    minc=p.dajCenu();
                    minP=p;
                }
            }
        }
        return minP;
    }
    
    //9
    public double srednjeTrajanje(int k){
        double sv=0;
        int br=0;
        for(Projekat p:projekti){
            if(p instanceof Visokogradnja && p.dajBrojZaposlenih()>k){
                sv+=p.dajTrajanje(); br++;
            }            
        }
        return sv/br;
    }
    
    //7
    public void odrediCene(){
        for(Projekat p:projekti){
            p.odrediCenu();
        }
    }
    
    //10
    public static void test(){
        Firma f=new Firma("Ptiza");
        Zaposleni z1=new Zaposleni("1212", "Pera Peric", "projektant");
        Zaposleni z2=new Zaposleni("1313", "Sima Simic", "tehnicar");        
        Projekat in=new Infrastruktura(20);
        Projekat vg=new Visokogradnja(18,3,2000,900);
        Deonica d1=new Deonica("s1", 10, 100000);
        Deonica d2=new Deonica("s2", 7, 200000);     
        in.dodajDeonicu(d1);       
        in.dodajDeonicu(d2);
        vg.dodajZaposlenog(z1);        vg.dodajZaposlenog(z2);        in.dodajZaposlenog(z1);
        f.dodajZaposlenog(z1);        f.dodajZaposlenog(z2);
        f.dodajProjekat(in);        f.dodajProjekat(vg);
        f.info();
        System.out.println(f.srednjeTrajanje(1));
    }
}